"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const react_1 = __importDefault(require("react"));
const io_1 = require("react-icons/io");
const md_1 = require("react-icons/md");
const react_2 = require("react");
const get_week_day_1 = __importDefault(require("../helper/get_week_day"));
const get_number_of_days_1 = __importDefault(require("../helper/get_number_of_days"));
const get_name_of_month_1 = __importDefault(require("../helper/get_name_of_month"));
const obj = {};
const styles = new Proxy(obj, {
    get(target, p) {
        return p;
    },
});
function Top_section({ setyear, setmonth, year, month, day }) {
    return (react_1.default.createElement("div", { className: styles.top_section },
        react_1.default.createElement("div", { className: styles.btn, style: { cursor: 'pointer' }, onClick: () => {
                setyear(perv => perv + 1);
            } },
            react_1.default.createElement(md_1.MdKeyboardDoubleArrowLeft, { size: 18, color: '#dbd8d8' })),
        react_1.default.createElement("div", { className: styles.btn, style: { marginRight: 20, cursor: 'pointer' }, onClick: () => {
                setmonth(perv => perv + 1 <= 12 ? perv + 1 : perv - 11);
            } },
            react_1.default.createElement(io_1.IoIosArrowBack, { size: 18, color: '#dbd8d8' })),
        react_1.default.createElement("h4", null,
            year,
            (0, get_name_of_month_1.default)(month)),
        react_1.default.createElement("div", { className: styles.btn, style: { marginLeft: 20, cursor: 'pointer' }, onClick: () => {
                setmonth(perv => perv - 1 >= 1 ? perv - 1 : perv + 11);
            } },
            react_1.default.createElement(io_1.IoIosArrowForward, { size: 18, color: '#dbd8d8' })),
        react_1.default.createElement("div", { className: styles.btn, style: { cursor: 'pointer' }, onClick: () => {
                setyear(perv => perv - 1);
            } },
            react_1.default.createElement(md_1.MdKeyboardDoubleArrowRight, { size: 18, color: '#dbd8d8' }))));
}
function Week_days() {
    return (react_1.default.createElement("div", { className: styles.week_days }, ['شنبه', 'یکشنبه', 'دوشنبه', 'سه شنبه', 'چهار شنبه', 'پنجشنبه', 'جمعه'].map((e) => {
        return (react_1.default.createElement("p", { key: e }, e));
    })));
}
function Days({ year, month, day, start, set_start, end, set_end, hover, set_hover }) {
    const [padding, setpadding] = (0, react_2.useState)(0);
    (0, react_2.useEffect)(() => {
        let a = (0, get_week_day_1.default)(year, month, day);
        setpadding(a + 1 == 7 ? 0 : a + 1);
    }, [year, month]);
    return (react_1.default.createElement("div", { className: styles.days },
        Array(padding).fill(null).map((e, index) => {
            return (react_1.default.createElement("div", { className: styles.day, style: { border: 'none' }, key: index }));
        }),
        Array((0, get_number_of_days_1.default)(month)).fill(null).map((e, index) => {
            let score = year * 1000 + month * 60 + index + 1;
            return (react_1.default.createElement("div", { key: index, className: styles.day, style: (score == start || score == end) ? { backgroundColor: 'black', color: 'white', cursor: 'pointer' } : (score > start && score < end) ? { backgroundColor: '#dbd8d8', color: 'black', cursor: 'pointer' } : (start && !end && score > start && score <= hover) ? { backgroundColor: '#dbd8d8', color: 'black', cursor: 'pointer' } : { cursor: (start && !end && hover < start) ? 'no-drop' : 'pointer' }, onMouseEnter: () => {
                    set_hover(score);
                }, onMouseOut: () => {
                    set_hover(0);
                }, onClick: () => {
                    if ((start && end) || (!start && !end)) {
                        set_end(0);
                        set_start(score);
                    }
                    else if (start && !end) {
                        if (score >= start)
                            set_end(score);
                    }
                } }, index + 1));
        })));
}
function RangeDatePicker({ callback, start_default_value, end_default_value }) {
    const [year, set_year] = (0, react_2.useState)(start_default_value.year);
    const [month, set_month] = (0, react_2.useState)(start_default_value.month);
    const [day, set_day] = (0, react_2.useState)(1);
    const [start_day, set_start] = (0, react_2.useState)(start_default_value.year * 1000 + start_default_value.month * 60 + start_default_value.day);
    const [end_day, set_end] = (0, react_2.useState)(end_default_value.year * 1000 + end_default_value.month * 60 + end_default_value.day);
    const [hover_day, set_hover] = (0, react_2.useState)(0);
    return (react_1.default.createElement("div", null,
        react_1.default.createElement("div", { className: styles.container },
            react_1.default.createElement(Top_section, { setmonth: set_month, setyear: set_year, year: year, month: month, day: day }),
            react_1.default.createElement(Week_days, null),
            react_1.default.createElement(Days, { year: year, day: day, month: month, start: start_day, set_start: set_start, end: end_day, set_end: set_end, hover: hover_day, set_hover: set_hover }),
            react_1.default.createElement("div", { style: { display: 'flex', marginTop: 20, justifyContent: 'space-between' } },
                react_1.default.createElement("div", { className: styles.cancel_btn, onClick: () => {
                        callback();
                    } },
                    react_1.default.createElement("p", null, "\u0644\u063A\u0648")),
                react_1.default.createElement("div", { className: styles.apply_btn, onClick: () => {
                        callback({
                            start: start_day ? '' + Math.floor(start_day / 1000) + '/' + Math.floor((start_day % 1000) / 60) + '/' + Math.floor((start_day % 1000) % 60) : null,
                            end: end_day ? '' + Math.floor(end_day / 1000) + '/' + Math.floor((end_day % 1000) / 60) + '/' + Math.floor((end_day % 1000) % 60) : null
                        });
                    } },
                    react_1.default.createElement("p", null, "\u0627\u0639\u0645\u0627\u0644"))))));
}
exports.default = RangeDatePicker;
